finish bind mount, removed in next commit
[distro-setup] / conflink
index 74ced8d47622fa9b000a465eac0138162fa69c5c..50747a327e57e9ca7be960ada8c5ac14c242eab7 100755 (executable)
--- a/conflink
+++ b/conflink
@@ -1,37 +1,33 @@
-#!/bin/bash -l
+#!/bin/bash
 
-set -eE -o pipefail
-trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
+source /a/bin/errhandle/errcatch-function
+source /a/bin/errhandle/bash-trace-function
 
+errcatch
 
-sysv() {
-    e "$@"
+m() {
+    echo "$*"
     "$@"
 }
-
-
-#
-if [[ -e /root/.unison && ! -L /root/.unison ]]; then
-    d=/q/p/c/machine_specific/$host/.unison
-    mkdir -p $d
-    mv -f /root/.unison/* $d
-fi
+s() { sudo "$@"; }
+lnf() { /a/exe/lnf "$@"; }
 
 
 shopt -s nullglob
-shopt -s extglob
+shopt -s extglob # note, already set with bash -l
 
-# if we make a link back to the root, traversing the subdirs stops.
-# This makes it so we can do subdir directories. Must call with absolute
-# paths.
+# If we make a link back to the root, we stop going deeper into subdir_files.
+# This makes it so we can do subdir directories.
+#
+# Also note, under filesystem/, symlinks are expanded.
 
 subdir-link-r() {
     local root="$1"
     local targets=()
     if [[ $2 ]]; then
-        targets=( "$2"/!(.git) )
+        targets=( "$2"/!(.git|..|.) )
     else
-        for f in "$1"/!(.git); do
+        for f in "$1"/!(.git|..|.); do
             [[ -d $f ]] && targets+=("$f") ||:
         done
     fi
@@ -40,53 +36,77 @@ subdir-link-r() {
         local fullpath="$(readlink -f "$path")"
         #e $fullpath $below # debug
         if [[ -f $path || $(dirname $(readlink -f "$fullpath")) == "$below" ]]; then
-            sysv lnf -T "$path" "$HOME/${path#$root/}"
+            m lnf -T "$path" "$HOME/${path#$root/}"
         elif [[ -d "$path" ]]; then
             subdir-link-r "$root" "$path"
         fi
     done
 }
 
+
+
 common-file-setup() {
+    local dir fs x bdir f dst
     for dir in "$@"; do
-        if [[ -e $dir/subdir_files ]]; then
-            subdir-link-r $dir/subdir_files
+        fs=$dir/filesystem
+        if [[ -e $fs && $USER == ian ]]; then
+            # note, symlinks get resolved, not copied.
+            m s cp -RLT --preserve=mode,timestamps $fs /
         fi
-        local x=( $dir/!(subdir_files|filesystem) )
-        (( ${#x[@]} >= 1 )) || return 0
-        sysv lnf ${x[@]} ~
-        # as of this writing, it doesn't exist in /a/c, but I've used it in the past.
-        if [[ -e $dir/filesystem && $USER == ian ]]; then
-            sysv s cp -R $dir/filesystem/* /
+
+        # one program so far does not work with a symlink,
+        # so we have to use a bind mount
+        bdir=$dir/binds
+        if [[ -e $bdir && $USER == ian ]]; then
+            for f in $(find $bdir -type f); do
+                dst=/home/ian/${f##$bdir}
+                binds+="$f $dst none bind 0 0"$'\n'
+                if [[ ! -e $dst || $(stat -c%i $f $dst |uniq -u) ]]; then
+                    if mountpoint -q $dst; then
+                        s umount $dst
+                    fi
+                    # note: in future, may need to mkdir also
+                    [[ -e $dst ]] || touch $dst
+                    s mount --bind $f $dst
+                fi
+            done
         fi
-    done
-}
 
-link-dirs() {
-    for dir in "$@"; do
-        common-file-setup $dir
-        common-file-setup $dir/machine_specific/$HOSTNAME
+        if [[ -e $dir/subdir_files ]]; then
+            subdir-link-r $dir/subdir_files
+        fi
+        local x=( $dir/!(binds|subdir_files|filesystem|machine_specific|..|.) )
+        (( ${#x[@]} >= 1 )) || continue
+        m lnf ${x[@]} ~
     done
 }
 
+binds=""
 all_dirs=({/a/c,/p/c}{,/machine_specific/$HOSTNAME})
+# note, we assume a group of hosts does not have the
+# same name as a single host, which is no problem on our scale.
+for x in /p/c/machine_specific/*.hosts; do
+    if grep -qxF $HOSTNAME $x; then all_dirs+=( ${x%.hosts} ); fi
+done
+
 c_dirs=(/a/c{,/machine_specific/$HOSTNAME})
 case $USER in
     ian)
         # p needs to go first so .ssh link is created, then config link inside it
-        common-file-setup $dir ${all_dirs[@]}
+        common-file-setup ${all_dirs[@]}
+        if [[ $binds ]]; then
+            s /a/exe/cedit conflink /etc/fstab <<<"$binds" || [[ $? == 1 ]]
+        fi
+        if [[ -d /etc/bind/bind-writable ]]; then
+            # need bind writable dir for nsupdate, or else we get
+            # named[20823]: /etc/bind/db.iank.pw.jnl: create: permission denied
+            s chgrp bind /etc/bind/bind-writable
+        fi
         sudo -u traci "$BASH_SOURCE"
         ;;
     traci)
         common-file-setup ${c_dirs[@]}
         ;;
-    root)
-        if ! $ROOTCMD getent passwd ian; then
-            common-file-setup ${all_dirs[@]}
-        else
-            echo "$0: error: unexpected user"; exit 1
-        fi
-        ;;
     *)
         echo "$0: error: unexpected user"; exit 1
         ;;